import java.lang.*;

// AppliChrono :
// Gestion d'un chronometre

public class AppliChrono 
{

	private long depart;
	private boolean fonction;

	// Cration : chronometre arrete

	public AppliChrono ()
	{
		depart = 0L;
		fonction = false;
	}

	// Observateur : etat du chronometre

	public boolean getEnFonction ()
	{
		return fonction;
	}

	// Observateur : temps ecoule sur le chronometre
	// Erreur si chronometre arrete

	public float getTempsEcoule ()
	{
		float f;
		if (! fonction)
		{
			f = 0.0F;
			this.traiterErreur("Demande de temps coul et Chronomtre arrte");
		}
		else
		{
			f = (System.currentTimeMillis() - depart) / 1000.0F;
		}
		return f;
	}

	// Transformateur : demarrage du chronometre
	// Erreur si chronometre en fonctionnement

	public void demarrer ()
	{
		if (fonction)
		{
			this.traiterErreur("Dmarrage du Chronomtre et Chronomtre dj en fonctionnement");
		}
		else
		{
			depart = System.currentTimeMillis();
			fonction = true;
		}
	}

	// Transformateur : arret du chronometre
	// Erreur si chronometre arrete

	public void arreter ()
	{
		if (! fonction)
		{
			this.traiterErreur ("Arrt du Chronomtre et Chronomtre dj arrt");
		}
		else
		{
			fonction = false;
			depart = 0L;
		}
	}

	// Mthode prive de gestion des erreurs
	// Affichage de message + arrt application

	private void traiterErreur (String message)
	{
		System.out.println("ERREUR (AppliChrono) : " + message);
		System.exit(0);
	}
}