import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import java.applet.Applet;

/** TP 3
 * Classe qui construit une fenetre avec plusieurs
 * boutons : Demarrer, Consulter, Arreter, quitter
 * On rajoute des observateurs de bouton et de label pour pouvoir acceder
 *  ceux-ci dans les listeners
 * author :  David MONTET
 */
class MaFen extends JFrame
{
     //Boutons de la fenetre
	 private JButton bDemarrer;
	 //Affiche le temps passee depuis le clic sur demarrer
	 //ou depuis le consulter precedent
	 private JButton bConsulter;
	 //Arrete le chrono pour de bon
	 private JButton bArreter;
	 private JButton bQuitter;

    // Zone d'affichage de texte
     private JLabel lEtiquette;
     private JLabel lAffichTemps;

    //Application chronometre   
	 private AppliChrono appli;
  	 
	//MaFen permet de construire une fenetre a partir 
	// d'un titre: titre de la fenetre
	// de la position sur l'ecran posX et posY
	public MaFen ( String titre, AppliChrono appliChr )
	{
		super (titre);
		//Enregistrement de l'application de chronometrage
		appli = appliChr;
		Container content;
		MaFenEcouteur ef;
       
		//Definition de la fenetre
		this.setBounds ( 20,30,400,130 );
		//Non redimensionable
		this.setResizable ( true );
		
		//**  Creation des composants
		content = this.getContentPane ();

		//Instanciation des tiquettes
		lAffichTemps = new JLabel ("Temps final : ");
		lEtiquette = new JLabel ("0.00 s");

		lEtiquette.setText( lAffichTemps.getText() + lEtiquette.getText() );
		//Instanciation  des 4 boutons
		bDemarrer  = new JButton ("Dmarrer");
		bConsulter = new JButton ("Consulter...");
		bArreter   = new JButton ("Arrter");
		bQuitter   = new JButton ("Quitter");
		
        //On cree le lien de composition
		content.add ( lAffichTemps );
		content.add (lEtiquette );
		content.add ( bDemarrer );
		content.add ( bConsulter );
		content.add ( bArreter );
		content.add ( bQuitter );

       //definition des couleurs		
		bDemarrer.setBackground  ( Color.green );
		bConsulter.setBackground ( Color.white );
		bArreter.setBackground   ( Color.red );
		bQuitter.setBackground  ( Color.magenta );
		
		//Position des boutons sur l'ecran
       content.setLayout ( new BorderLayout() );
       content.add ( lAffichTemps,BorderLayout.NORTH );
       content.add ( lEtiquette,BorderLayout.NORTH );
       content.add ( bDemarrer, BorderLayout.WEST );
       content.add ( bConsulter,BorderLayout.CENTER );
       content.add ( bArreter, BorderLayout.EAST );
       content.add (bQuitter, BorderLayout.SOUTH );     
       
		//Preparation des gestionnaires d'evenements
		EcouteurDemarrer eDemarrer = new EcouteurDemarrer ( this, bDemarrer);
		bDemarrer.addActionListener (eDemarrer);
		EcouteurConsulter eConsulter = new EcouteurConsulter ( this,bConsulter );
	    bConsulter.addActionListener (eConsulter);	
	    EcouteurArreter eArreter = new EcouteurArreter ( this,bArreter );
	    bArreter.addActionListener (eArreter);
	    EcouteurQuitter eQuitter = new EcouteurQuitter ( this,bQuitter);
	    bQuitter.addActionListener (eQuitter);
	   
   } 
   //retourne l'application chrono
   public AppliChrono getAppli ()
   {
     return appli;
   }
   //retourne la zone de texte qui affiche le temps XXX.XX
   public JLabel getEtiquetteTemps ()
   {
      return lEtiquette;
   }
   //retourne la zone de texte fixe
   public JLabel getEtiquetteFixe ()
   {
     return lAffichTemps;
   }
   
   //Retourne le bouton arreter
   public JButton getArreter ()
   {
     return bArreter;
   }
   public JButton getQuitter ()
   {
      return bQuitter;
   }
   public JButton getDemarrer ()
   {
      return bDemarrer;
   }
   public JButton getConsulter ()
   {
     return bConsulter;
   }
}
